/*
 * Copyright (c) 2009-2011 Yoshikazu Kuramochi
 * All rights reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package ch.kuramo.javie.core.services;

import java.util.Set;
import java.util.concurrent.locks.ReentrantLock;

import javax.media.opengl.GLCapabilitiesImmutable;
import javax.media.opengl.GLContext;
import javax.media.opengl.awt.GLCanvas;

public interface GLGlobal {

	ReentrantLock getGlobalLock();


	String getInitError();

	GLContext getSharedContext();

	boolean isMacOSX();

	boolean isWindows();

	boolean isIntel();

	boolean isAmdAti();

	boolean isNvidia();

	boolean isRadeonHD5k6k();

	String getDriverVersion();

	int getMaxSamples();

	int getMaxTextureImageUnits();

	Set<String> getExtensions();

	String getReport();


	void enterPoolMode(int poolSize);

	GLContext createContext();

	void destroyContext(GLContext context);


	GLCapabilitiesImmutable getCanvasCapabilities();

	void setCanvasCapabilities(GLCapabilitiesImmutable capabilities);

	GLCanvas createCanvas();

}
